#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX 1000

struct child {
    char name[64];
    int age;
};

int compare(const void* ap, const void* bp) {
    struct child* a = (struct child*) ap;
    struct child* b = (struct child*) bp;

    /* if they are both odd, go in order */
    if ((a->age % 2 != 0) && (b->age % 2 != 0)) return (a->age - b->age);

    /* if they are both even, go in reverse order */
    if ((a->age % 2 == 0) && (b->age % 2 == 0)) return (b->age - a->age);

    /* if one is odd, put it first */
    if ((a->age % 2 != 0) && (b->age % 2 == 0)) return -1;

    /* else put the other one first */
    else return 1;
}

int main() {
    struct child children[MAX];
    int n = 0, i;
    
    while (scanf("%[^:]: %d\n", children[n].name, &children[n].age) == 2) {
        n++;
    }

    qsort(children, n, sizeof(struct child), &compare);

    printf("Team 1\n");
    int first = 1;
    for (i = 0; i < n; i++) {
        if ((children[i].age % 2 == 0) && first) {
            first = 0;
            printf("\nTeam 2\n");
        }

        printf("%s: %d\n", children[i].name, children[i].age);
    }

    return 0;
}

