#include <stdio.h>

int search(char board[4][8], int r, int c) {
    /* if we got to the "other side", YES */
    if (r < 0) return 1;

    /* if out of bounds, no good */
    if (r > 3) return 0;
    if ((c < 0) || (c > 7)) return 0;

    /* if this spot is marked, no good */
    if (board[r][c] == '-') return 0;

    /* if mountain, no good */
    if (board[r][c] == 'M') return 0;

    /* mark this spot as visited */
    board[r][c] = '-';

    /* recurse in all directions */
    if (search(board, r, c - 1)) return 1;
    if (search(board, r, c + 1)) return 1;
    if (search(board, r - 1, c)) return 1;
    if (search(board, r + 1, c)) return 1;

    /* if we get here, no way */
    return 0;
}

/* checks if the fortress is accessible */
int fortress_accessible(char board[4][8]) {
    int r, c;

    for (r = 0; r < 4; r++) {
        for (c = 0; c < 8; c++) {
            if (board[r][c] == 'X') {
                return search(board, r, c);
            }
        }
    }
}


int main() {
    char board[4][8], dummy;
    int num, i, j, k;

    scanf("%d\n", &num);

    /* each test */
    for (i = 0; i < num; i++) {
        /* each row */
        for (j = 0; j < 4; j++) {
            /* each col */
            for (k = 0; k < 8; k++) {
                scanf("%c", &board[j][k]);
            }
            scanf("\n");
        }

        /* skip the "-" */
        scanf("%c\n", &dummy);

        /* run it */
        if (fortress_accessible(board)) {
            printf("Fortress accessible.\n");
        } else {
            printf("Fortress inaccessible.\n");
        }   
    }

    return 0;
}



