
#include <stdio.h>
#include <string.h>


typedef struct {
    int x, y;
} Point;


/* just use "left" instead */
int point_left_of_vetrical(Point point, int wallx) {
    if (point.x < wallx)
        return 1;
    else
        return 0;
}

int point_above_line(Point point, Point walla, Point wallb) {
    double m, b, line_y;

    /* this function works for all walls that are not straight vertical
       for those, we need a special case */
    if (walla.x == wallb.x) {
        return point_left_of_vetrical(point, walla.x);
    }

    /* convert line from (point,point) to y = mx + b form */
    m = ((double)walla.y - (double)wallb.y) / 
        ((double)walla.x - (double)wallb.x);
    b = walla.y - m*walla.x;

    /* now we can find the line's y-value at the point's x: */
    line_y = m*point.x + b;

    /* if the point's y is above the lines, then true */
    if (point.y >= line_y)
        return 1;
    else
        return 0;
}

int separates(Point* a, int asize, Point* b, int bsize, Point walla, Point wallb) {

    int first_left, i;

    if (point_above_line(a[0], walla, wallb)) {
        first_left = 1;
    } else {
        first_left = 0;
    }

    /* for each point in camp a */
    for (i = 0; i < asize; i++) {
        if (first_left && point_above_line(a[i], walla, wallb)) {
        } else if (!first_left && !point_above_line(a[i], walla, wallb)) {
        } else {
            return 0;
        }
    }

    /* for each point in camp b */
    for (i = 0; i < bsize; i++) {
        if (first_left && !point_above_line(b[i], walla, wallb)) {
        } else if (!first_left && point_above_line(b[i], walla, wallb)) {
        } else {
            return 0;
        }
    }

    return 1;
}


void handle_case(Point* a, int asize, Point* b, int bsize, Point walla, Point wallb) {
    if (separates(a, asize, b, bsize, walla, wallb)) {
        printf("Wall separates camps.\n");
    } else {
        printf("Wall does not separate camps.\n");
    }
}


int main() {
    char line[100];
    Point a[100], b[100], walla, wallb;
    int asize = 0, bsize = 0;
    int read = 0;

    while (1) {
        scanf("%s", line);

        switch (line[0]) {
            case 'A':
                if (read) {
                    /* do last one */
                    handle_case(a, asize, b, bsize, walla, wallb);
                    asize = bsize = 0;
                }
                read = 1;
                break;
            case 'B':
                read = 2;
                break;
            case 'W':
                read = 3;
                break;
            case '$':
                handle_case(a, asize, b, bsize, walla, wallb);
                asize = bsize = 0;
                return 0;
                break;
            default:
                /* a number */
                if (read == 1) {
                    sscanf(line, "%d,%d", &a[asize].x, &a[asize].y);
                    asize++;
                } else if (read == 2) {
                    sscanf(line, "%d,%d", &b[bsize].x, &b[bsize].y);
                    bsize++;
                } else if (read == 3) {
                    sscanf(line, "%d,%d", &walla.x, &walla.y);
                    read++;
                } else {
                    sscanf(line, "%d,%d", &wallb.x, &wallb.y);
                }
                break;
        }
    }

    return 0;
}


